/***********************************************************************/
/*                                                                     */
/*  FILE        :iodefine.h                                            */
/*  DATE        :Mon, May 31, 2010                                     */
/*  DESCRIPTION :define the sfr register. (for C language)             */
/*  CPU GROUP   :62A(ROM256K)                                          */
/*                                                                     */
/*  This file is generated by KPIT GNU Project Generator.              */
/*                                                                     */
/***********************************************************************/

#ifndef IODEFINE_H 
#define IODEFINE_H

/****************************************************************************
*                                                                           *
*   file name   : definition of M16C/62A's SFR                              *
*                                                                           *
*****************************************************************************/

/********************************************************

*   declare SFR addresses                               *

********************************************************/



#define     pm0    (*(volatile union byte_def *) (0x0004))       /* Processor mode register 0 */



#define     pm1    (*(volatile union byte_def *) (0x0005))       /* Processor mode register 1 */



#define     cm0    (*(volatile union byte_def *) (0x0006))       /* System clock control register 0 */



#define     cm1    (*(volatile union byte_def *) (0x0007))       /* System clock control register 1 */



#define     csr    (*(volatile union byte_def *) (0x0008))       /* Chip select control register */



#define     aier   (*(volatile union byte_def *) (0x0009))       /* Address match interrupt enable register */



#define     prcr   (*(volatile union byte_def *) (0x000a))       /* Protect register */



/* #define     dbr    (*(volatile union byte_def *) (0x000b)) */      /* Data bank register */



#define     wdts   (*(volatile union byte_def *) (0x000e))       /* Watchdog timer start register */



#define     wdc    (*(volatile union byte_def *) (0x000f))       /* Watchdog timer control register */



#define     rmad0  (*(volatile union word_def_1 *) (0x0010))       /* Address match interrupt register 0 */



#define     rmad1  (*(volatile union word_def_1 *) (0x0014))       /* Address match interrupt register 1 */



#define     sar0   (*(volatile union word_def_1 *) (0x0020))       /* DMA0 source pointer */



#define     dar0   (*(volatile union word_def_1 *) (0x0024))       /* DMA0 destination pointer */



#define     tcr0   (*(volatile union word_def_2 *) (0x0028))       /* DMA0 transfer counter */



#define     dm0con (*(volatile union dmicon *) (0x002c))       /* DMA0 control register */



#define     sar1   (*(volatile union word_def_1 *) (0x0030))       /* DMA1 source pointer */



#define     dar1   (*(volatile union word_def_1 *) (0x0034))       /* DMA1 destination pointer */



#define     tcr1   (*(volatile union word_def_2 *) (0x0038))       /* DMA1 transfer counter */



#define     dm1con (*(volatile union dmicon *) (0x003c))       /* DMA1 control register */



#define     int3ic (*(volatile union intcr *) (0x0044))       /* INT3~ interrupt control register */



#define     tb5ic  (*(volatile union intcr *) (0x0045))       /* Timer B5 interrupt control register */



#define     tb4ic  (*(volatile union intcr *) (0x0046))       /* Timer B4 interrupt control register */



#define     tb3ic  (*(volatile union intcr *) (0x0047))       /* Timer B3 interrupt control register */



#define     s4ic   (*(volatile union intcr *) (0x0048))       /* SI/O4 interrupt control register */



#define     s3ic   (*(volatile union intcr *) (0x0049))       /* SI/O3 interrupt control register */



#define     int5ic (*(volatile union intcr *) (0x0048))       /* INT5~ interrupt control register */



#define     int4ic (*(volatile union intcr *) (0x0049))       /* INT4~ interrupt control register */



#define     bcnic  (*(volatile union intcr *) (0x004a))       /* Bus collision detection interrupt control register */



#define     dm0ic  (*(volatile union intcr *) (0x004b))       /* DMA0 interrupt control register */



#define     dm1ic  (*(volatile union intcr *) (0x004c))       /* DMA1 interrupt control register */



#define     kupic  (*(volatile union intcr *) (0x004d))       /* Key input interrupt control register */



#define     adic   (*(volatile union intcr *) (0x004e))       /* A/D conversion interrupt control register */



#define     s2tic  (*(volatile union intcr *) (0x004f))       /* UART2 transmit interrupt control register */



#define     s2ric  (*(volatile union intcr *) (0x0050))       /* UART2 receive interrupt control register */



#define     s0tic  (*(volatile union intcr *) (0x0051))       /* UART0 transmit interrupt control register */



#define     s0ric  (*(volatile union intcr *) (0x0052))       /* UART0 receive interrupt control register */



#define     s1tic  (*(volatile union intcr *) (0x0053))       /* UART1 transmit interrupt control register */



#define     s1ric  (*(volatile union intcr *) (0x0054))       /* UART1 receive interrupt control register */



#define     ta0ic  (*(volatile union intcr *) (0x0055))       /* Timer A0 interrupt control register */



#define     ta1ic  (*(volatile union intcr *) (0x0056))       /* Timer A1 interrupt control register */



#define     ta2ic  (*(volatile union intcr *) (0x0057))       /* Timer A2 interrupt control register */



#define     ta3ic  (*(volatile union intcr *) (0x0058))       /* Timer A3 interrupt control register */



#define     ta4ic  (*(volatile union intcr *) (0x0059))       /* Timer A4 interrupt control register */



#define     tb0ic  (*(volatile union intcr *) (0x005a))       /* Timer B0 interrupt control register */



#define     tb1ic  (*(volatile union intcr *) (0x005b))       /* Timer B1 interrupt control register */



#define     tb2ic  (*(volatile union intcr *) (0x005c))       /* Timer B2 interrupt control register */



#define     int0ic (*(volatile union intcr *) (0x005d))       /* INT0~ interrupt control register */



#define     int1ic (*(volatile union intcr *) (0x005e))       /* INT1~ interrupt control register */



#define     int2ic (*(volatile union intcr *) (0x005f))       /* INT2~ interrupt control register */



#define     tbsr   (*(volatile union byte_def *) (0x0340))       /* Timer B3,4,5 count start flag */



#define     ta11   (*(volatile unsigned short *) (0x0342))       /* Timer A1-1 register */



#define     ta21   (*(volatile unsigned short *) (0x0344))       /* Timer A2-1 register */



#define     ta41   (*(volatile unsigned short *) (0x0346))       /* Timer A4-1 register */



#define     invc0  (*(volatile union byte_def *) (0x0348))       /* Three-phase PWM control regester 0 */



#define     invc1  (*(volatile union byte_def *) (0x0349))       /* Three-phase PWM control register 1 */



#define     idb0   (*(volatile union byte_def *) (0x034a))       /* Three-phase output buffer register 0 */



#define     idb1   (*(volatile union byte_def *) (0x034b))       /* Three-phase output buffer register 1 */



#define     dtt    (*(volatile union byte_def *) (0x034c))       /* Dead time timer */



#define     ictb2  (*(volatile union byte_def *) (0x034d))       /* Timer B2 interrupt occurrences frequency set counter */



#define     tb3    (*(volatile unsigned short *) (0x0350))       /* Timer B3 register */



#define     tb4    (*(volatile unsigned short *) (0x0352))       /* Timer B4 register */



#define     tb5    (*(volatile unsigned short *) (0x0354))       /* Timer B5 register */



#define     tb3mr  (*(volatile union timr *) (0x035b))       /* Timer B3 mode register */



#define     tb4mr  (*(volatile union timr *) (0x035c))       /* Timer B4 mode register */



#define     tb5mr  (*(volatile union timr *) (0x035d))       /* Timer B5 mode register */



#define     ifsr   (*(volatile union byte_def *) (0x035f))       /* Interrupt cause select register */



#define     s3trr  (*(volatile union byte_def *) (0x0360))       /* SI/O3 transmit/receive register */



#define     s3c    (*(volatile union sic *) (0x0362))       /* SI/O3 control register */



#define     s3brg  (*(volatile union byte_def *) (0x0363))       /* SI/O3 bit rate generator */



#define     s4trr  (*(volatile union byte_def *) (0x0364))       /* SI/O4 transmit/receive register */



#define     s4c    (*(volatile union sic *) (0x0366))       /* SI/O4 control register */



#define     s4brg  (*(volatile union byte_def *) (0x0367))       /* SI/O4 bit rate generator */



#define     u2smr3 (*(volatile union byte_def *) (0x0375))       /* UART2 special mode register 3 */



#define     u2smr2 (*(volatile union byte_def *) (0x0376))       /* UART2 special mode register 2 */



#define     u2smr  (*(volatile union byte_def *) (0x0377))       /* UART2 special mode register */



#define     u2mr   (*(volatile union uimr *) (0x0378))       /* UART2 transmit/receive mode register */



#define     u2brg  (*(volatile union byte_def *) (0x0379))       /* UART2 bit rate generator */



#define     u2tb   (*(volatile union word_def_2 *) (0x037a))       /* UART2 transmit buffer register */



#define     u2c0   (*(volatile union uic0 *) (0x037c))       /* UART2 transmit/receive control register 0 */



#define     u2c1   (*(volatile union byte_def *) (0x037d))       /* UART2 transmit/receive control register 1 */



#define     u2rb   (*(volatile union uirb *) (0x037e))       /* UART2 receive buffer register */



#define     tabsr  (*(volatile union byte_def *) (0x0380))       /* Count start flag */



#define     cpsrf  (*(volatile union byte_def *) (0x0381))       /* Clock prescaler reset flag */



#define     onsf   (*(volatile union byte_def *) (0x0382))       /* One-shot start flag */



#define     trgsr  (*(volatile union byte_def *) (0x0383))       /* Trigger select register */



#define     udf    (*(volatile unsigned char *) (0x0384))       /* Up/down flag */



#define     ta0    (*(volatile unsigned short *) (0x0386))       /* Timer A0 register */



#define     ta1    (*(volatile unsigned short *) (0x0388))       /* Timer A1 register */



#define     ta2    (*(volatile unsigned short *) (0x038a))       /* Timer A2 register */



#define     ta3    (*(volatile unsigned short *) (0x038c))       /* Timer A3 register */



#define     ta4    (*(volatile unsigned short *) (0x038e))       /* Timer A4 register */



#define     tb0    (*(volatile unsigned short *) (0x0390))       /* Timer B0 register */



#define     tb1    (*(volatile unsigned short *) (0x0392))       /* Timer B1 register */



#define     tb2    (*(volatile unsigned short *) (0x0394))       /* Timer B2 register */



#define     ta0mr  (*(volatile union timr *) (0x0396))       /* Timer A0 mode register */



#define     ta1mr  (*(volatile union timr *) (0x0397))       /* Timer A1 mode register */



#define     ta2mr  (*(volatile union timr *) (0x0398))       /* Timer A2 mode register */



#define     ta3mr  (*(volatile union timr *) (0x0399))       /* Timer A3 mode register */



#define     ta4mr  (*(volatile union timr *) (0x039a))       /* Timer A4 mode register */



#define     tb0mr  (*(volatile union timr *) (0x039b))       /* Timer B0 mode register */



#define     tb1mr  (*(volatile union timr *) (0x039c))       /* Timer B1 mode register */



#define     tb2mr  (*(volatile union timr *) (0x039d))       /* Timer B2 mode register */



#define     u0mr   (*(volatile union uimr *) (0x03a0))       /* UART0 transmit/receive mode register */



#define     u0brg  (*(volatile union byte_def *) (0x03a1))       /* UART0 bit rate generator */



#define     u0tb   (*(volatile union word_def_2 *) (0x03a2))       /* UART0 transmit buffer register */



#define     u0c0   (*(volatile union uic0 *) (0x03a4))       /* UART0 transmit/receive control register 0 */



#define     u0c1   (*(volatile union uic1 *) (0x03a5))       /* UART0 transmit/receive control register 1 */



#define     u0rb   (*(volatile union uirb *) (0x03a6))       /* UART0 receive buffer register */



#define     u1mr   (*(volatile union uimr *) (0x03a8))       /* UART1 transmit/receive mode register */



#define     u1brg  (*(volatile union byte_def *) (0x03a9))       /* UART1 bit rate generator */



#define     u1tb   (*(volatile union word_def_2 *) (0x03aa))       /* UART1 transmit buffer register */



#define     u1c0   (*(volatile union uic0 *) (0x03ac))       /* UART1 transmit/receive control register 0 */



#define     u1c1   (*(volatile union uic1 *) (0x03ad))       /* UART1 transmit/receive control register 1 */



#define     u1rb   (*(volatile union uirb *) (0x03ae))       /* UART1 receive buffer register */



#define     ucon   (*(volatile union byte_def *) (0x03b0))       /* UART transmit/receive control register 2 */



#define     fmr1   (*(volatile union fmr1_def *) (0x03b6))       /* Flash memory control register 1 */



#define     fmr0   (*(volatile union fmr0_def *) (0x03b7))       /* Flash memory control register 0 */



#define     dm0sl  (*(volatile union dmisl *) (0x03b8))       /* DMA0 cause select register */



#define     dm1sl  (*(volatile union dmisl *) (0x03ba))       /* DMA1 cause select register */



#define     crcd   (*(volatile union word_def_2 *) (0x03bc))       /* CRC data register */



#define     crcin  (*(volatile union byte_def *) (0x03be))       /* CRC input register */



#define     ad0    (*(volatile union word_def_2 *) (0x03c0))       /* A/D register 0 */



#define     ad1    (*(volatile union word_def_2 *) (0x03c2))       /* A/D register 1 */



#define     ad2    (*(volatile union word_def_2 *) (0x03c4))       /* A/D register 2 */



#define     ad3    (*(volatile union word_def_2 *) (0x03c6))       /* A/D register 3 */



#define     ad4    (*(volatile union word_def_2 *) (0x03c8))       /* A/D register 4 */



#define     ad5    (*(volatile union word_def_2 *) (0x03ca))       /* A/D register 5 */



#define     ad6    (*(volatile union word_def_2 *) (0x03cc))       /* A/D register 6 */



#define     ad7    (*(volatile union word_def_2 *) (0x03ce))       /* A/D register 7 */



#define     adcon2 (*(volatile union byte_def *) (0x03d4))       /* A/D control register 2 */



#define     adcon0 (*(volatile union byte_def *) (0x03d6))       /* A/D control register 0 */



#define     adcon1 (*(volatile union byte_def *) (0x03d7))       /* A/D control register 1 */



#define     da0    (*(volatile unsigned char *) (0x03d8))       /* D/A register 0 */



#define     da1    (*(volatile unsigned char *) (0x03da))       /* D/A register 1 */



#define     dacon  (*(volatile union byte_def *) (0x03dc))       /* D/A control register */



#define     p0     (*(volatile union byte_def *) (0x03e0))       /* Port P0 register */



#define     p1     (*(volatile union byte_def *) (0x03e1))       /* Port P1 register */



#define     pd0    (*(volatile union byte_def *) (0x03e2))       /* Port P0 direction register */



#define     pd1    (*(volatile union byte_def *) (0x03e3))       /* Port P1 direction register */



#define     p2     (*(volatile union byte_def *) (0x03e4))       /* Port P2 register */



#define     p3     (*(volatile union byte_def *) (0x03e5))       /* Port P3 register */



#define     pd2    (*(volatile union byte_def *) (0x03e6))       /* Port P2 direction register */



#define     pd3    (*(volatile union byte_def *) (0x03e7))       /* Port P3 direction register */



#define     p4     (*(volatile union byte_def *) (0x03e8))       /* Port P4 register */



#define     p5     (*(volatile union byte_def *) (0x03e9))       /* Port P5 register */



#define     pd4    (*(volatile union byte_def *) (0x03ea))       /* Port P4 direction register */



#define     pd5    (*(volatile union byte_def *) (0x03eb))       /* Port P5 direction register */



#define     p6     (*(volatile union byte_def *) (0x03ec))       /* Port P6 register */



#define     p7     (*(volatile union byte_def *) (0x03ed))       /* Port P7 register */



#define     pd6    (*(volatile union byte_def *) (0x03ee))       /* Port P6 direction register */



#define     pd7    (*(volatile union byte_def *) (0x03ef))       /* Port P7 direction register */



#define     p8     (*(volatile union byte_def *) (0x03f0))       /* Port P8 register */



#define     p9     (*(volatile union byte_def *) (0x03f1))       /* Port P9 register */



#define     pd8    (*(volatile union byte_def *) (0x03f2))       /* Port P8 direction register */



#define     pd9    (*(volatile union byte_def *) (0x03f3))       /* Port P9 direction register */



#define     p10    (*(volatile union byte_def *) (0x03f4))       /* Port P10 register */



#define     pd10   (*(volatile union byte_def *) (0x03f6))       /* Port P10 direction register */



#define     pur0   (*(volatile union byte_def *) (0x03fc))       /* Pull-up control register 0 */



#define     pur1   (*(volatile union byte_def *) (0x03fd))       /* Pull-up control register 1 */



#define     pur2   (*(volatile union byte_def *) (0x03fe))       /* Pull-up control register 2 */



#define     pcr    (*(volatile union byte_def *) (0x03ff))       /* Port control register */



/********************************************************

*   declare  SFR char                                   *

********************************************************/


/*--------------------------------------------------------

    Up/down flag ; Use "MOV" instruction when writing to this register.

--------------------------------------------------------*/


/********************************************************

*   declare  SFR short                                  *

********************************************************/

/*--------------------------------------------------------

    Timer registers : Read and write data in 16-bit units.

--------------------------------------------------------*/



/********************************************************

*   declare SFR bit                                     *

********************************************************/

struct bit_def {

        char    b0:1;

        char    b1:1;

        char    b2:1;

        char    b3:1;

        char    b4:1;

        char    b5:1;

        char    b6:1;

        char    b7:1;

};

union byte_def{

    struct bit_def bit;

    char    byte;

};



/*------------------------------------------------------

    Processor mode register 0

------------------------------------------------------*/







#define     pm00        pm0.bit.b0     /* Processor mode bit */

#define     pm01        pm0.bit.b1     /* Processor mode bit */

#define     pm02        pm0.bit.b2     /* R/W mode select bit */

#define     pm03        pm0.bit.b3     /* Software reset bit */

#define     pm04        pm0.bit.b4     /* Multiplexed bus space select bit */

#define     pm05        pm0.bit.b5     /* Multiplexed bus space select bit */

#define     pm06        pm0.bit.b6     /* Port P40 to P43 function select bit */

#define     pm07        pm0.bit.b7     /* BCLK output disable bit */



/*------------------------------------------------------

    Processor mode register 1

------------------------------------------------------*/







#define     pm13        pm1.bit.b3     /* Intermal reserved area expansion bit */

/* #define     pm14        pm1.bit.b4 */    /* Memory area expansion bit */

/* #define     pm15        pm1.bit.b5 */    /* Memory area expansion bit */

#define     pm17        pm1.bit.b7     /* Wait bit */



/*------------------------------------------------------

    System clock control register 0

------------------------------------------------------*/







#define     cm00        cm0.bit.b0     /* Clock output function select bit */

#define     cm01        cm0.bit.b1     /* Clock output function select bit */

#define     cm02        cm0.bit.b2     /* WAIT peripheral function clock stop bit */

#define     cm03        cm0.bit.b3     /* Xcin-Xcout drive capacity select bit */

#define     cm04        cm0.bit.b4     /* Port Xc select bit */

#define     cm05        cm0.bit.b5     /* Main clock stop bit */

#define     cm06        cm0.bit.b6     /* Main clock division select bit 0 */

#define     cm07        cm0.bit.b7     /* System clock select bit */



/*------------------------------------------------------

    System clock control register 1

------------------------------------------------------*/







#define     cm10        cm1.bit.b0     /* All clock stop control bit */

#define     cm15        cm1.bit.b5     /* Xin-Xout drive capacity select bit */

#define     cm16        cm1.bit.b6     /* Main clock division select bit 1 */

#define     cm17        cm1.bit.b7     /* Main clock division select bit 1 */



/*------------------------------------------------------

    Chip select control register

------------------------------------------------------*/







#define     cs0         csr.bit.b0     /* CS0~ output enable bit */

#define     cs1         csr.bit.b1     /* CS1~ output enable bit */

#define     cs2         csr.bit.b2     /* CS2~ output enable bit */

#define     cs3         csr.bit.b3     /* CS3~ output enable bit */

#define     cs0w        csr.bit.b4     /* CS0~ wait bit */

#define     cs1w        csr.bit.b5     /* CS1~ wait bit */

#define     cs2w        csr.bit.b6     /* CS2~ wait bit */

#define     cs3w        csr.bit.b7     /* CS3~ wait bit */



/*------------------------------------------------------

    Address match interrupt enable register

------------------------------------------------------*/







#define     aier0       aier.bit.b0    /* Address match interrupt 0 enable bit */

#define     aier1       aier.bit.b1    /* Address match interrupt 1 enable bit */



/*------------------------------------------------------

    Protect register

------------------------------------------------------*/







#define     prc0        prcr.bit.b0    /* Enables writing to system clock control registers 0 and 1 */

#define     prc1        prcr.bit.b1    /* Enables writing to processor mode registers 0 and 1 */

#define     prc2        prcr.bit.b2    /* Enables writing to port P9 direction register and SI/Oi control register(i=3,4) */



/*------------------------------------------------------

    Data bank register

------------------------------------------------------*/

/*

/* #define     dbr         dbr.byte */



/* #define     ofs         dbr.bit.b2 */    /* Offset bit */

/* #define     bsr0        dbr.bit.b3 */    /* Bank select bit 0 */

/* #define     bsr1        dbr.bit.b4 */    /* Bank select bit 1 */

/* #define     bsr2        dbr.bit.b5 */    /* Bank select bit 2 */



/*------------------------------------------------------

    Watchdog timer start register

------------------------------------------------------*/







/*------------------------------------------------------

    CRC input register

------------------------------------------------------*/







/*------------------------------------------------------

    Watchdog timer control register

------------------------------------------------------*/







#define     wdc7        wdc.bit.b7     /* Prescaler select bit */



/*------------------------------------------------------

    Count start flag

------------------------------------------------------*/







#define     ta0s        tabsr.bit.b0   /* Timer A0 count start flag */

#define     ta1s        tabsr.bit.b1   /* Timer A1 count start flag */

#define     ta2s        tabsr.bit.b2   /* Timer A2 count start flag */

#define     ta3s        tabsr.bit.b3   /* Timer A3 count start flag */

#define     ta4s        tabsr.bit.b4   /* Timer A4 count start flag */

#define     tb0s        tabsr.bit.b5   /* Timer B0 count start flag */

#define     tb1s        tabsr.bit.b6   /* Timer B1 count start flag */

#define     tb2s        tabsr.bit.b7   /* Timer B2 count start flag */



/*------------------------------------------------------

    Timer B3,4,5 Count start flag

------------------------------------------------------*/







#define     tb3s        tbsr.bit.b5    /* Timer B3 count start flag */

#define     tb4s        tbsr.bit.b6    /* Timer B4 count start flag */

#define     tb5s        tbsr.bit.b7    /* Timer B5 count start flag */



/*------------------------------------------------------

    Three-phase PWM control regester 0

------------------------------------------------------*/







#define     inv00       invc0.bit.b0   /* Effective interrupt output polarity select bit */

#define     inv01       invc0.bit.b1   /* Effective interrupt output specification bit */

#define     inv02       invc0.bit.b2   /* Mode select bit */

#define     inv03       invc0.bit.b3   /* Output control bit */

#define     inv04       invc0.bit.b4   /* Positive and negative phases concurrent L output disable function enable bit */

#define     inv05       invc0.bit.b5   /* Positive and negative phases concurrent L output detect flag */

#define     inv06       invc0.bit.b6   /* Modulation mode select bit */

#define     inv07       invc0.bit.b7   /* Software trigger bit */



/*------------------------------------------------------

    Three-phase PWM control regester 1

------------------------------------------------------*/







#define     inv10       invc1.bit.b0   /* Timer Ai start trigger signal select bit */

#define     inv11       invc1.bit.b1   /* Timer A1-1,A2-1,A4-1 control bit */

#define     inv12       invc1.bit.b2   /* Short circuit timer count source select bit */



/*------------------------------------------------------

    Three-phase output buffer register 0

------------------------------------------------------*/







#define     du0         idb0.bit.b0    /* U  phase output buffer 0 */

#define     dub0        idb0.bit.b1    /* U~ phase output buffer 0 */

#define     dv0         idb0.bit.b2    /* V  phase output buffer 0 */

#define     dvb0        idb0.bit.b3    /* V~ phase output buffer 0 */

#define     dw0         idb0.bit.b4    /* W  phase output buffer 0 */

#define     dwb0        idb0.bit.b5    /* W~ phase output buffer 0 */



/*------------------------------------------------------

    Three-phase output buffer register 1

------------------------------------------------------*/







#define     du1         idb1.bit.b0    /* U  phase output buffer 1 */

#define     dub1        idb1.bit.b1    /* U~ phase output buffer 1 */

#define     dv1         idb1.bit.b2    /* V  phase output buffer 1 */

#define     dvb1        idb1.bit.b3    /* V~ phase output buffer 1 */

#define     dw1         idb1.bit.b4    /* W  phase output buffer 1 */

#define     dwb1        idb1.bit.b5    /* W~ phase output buffer 1 */



/*------------------------------------------------------

     Dead time timer ; Use "MOV" instruction when writing to this register.

------------------------------------------------------*/







/*------------------------------------------------------------------

     Timer B2 interrupt occurrences frequency set counter

     ; Use "MOV" instruction when writing to this register.

-------------------------------------------------------------------*/







/*------------------------------------------------------

    One-shot start flag

------------------------------------------------------*/







#define     ta0os       onsf.bit.b0    /* Timer A0 one-shot start flag */

#define     ta1os       onsf.bit.b1    /* Timer A1 one-shot start flag */

#define     ta2os       onsf.bit.b2    /* Timer A2 one-shot start flag */

#define     ta3os       onsf.bit.b3    /* Timer A3 one-shot start flag */

#define     ta4os       onsf.bit.b4    /* Timer A4 one-shot start flag */

#define     ta0tgl      onsf.bit.b6    /* Timer A0 event/trigger select bit */

#define     ta0tgh      onsf.bit.b7    /* Timer A0 event/trigger select bit */



/*------------------------------------------------------

    Clock prescaler reset flag

------------------------------------------------------*/







#define     cpsr        cpsrf.bit.b7   /* Clock prescaler reset flag */



/*------------------------------------------------------

    Trigger select register

------------------------------------------------------*/







#define     ta1tgl      trgsr.bit.b0   /* Timer A1 event/trigger select bit */

#define     ta1tgh      trgsr.bit.b1   /* Timer A1 event/trigger select bit */

#define     ta2tgl      trgsr.bit.b2   /* Timer A2 event/trigger select bit */

#define     ta2tgh      trgsr.bit.b3   /* Timer A2 event/trigger select bit */

#define     ta3tgl      trgsr.bit.b4   /* Timer A3 event/trigger select bit */

#define     ta3tgh      trgsr.bit.b5   /* Timer A3 event/trigger select bit */

#define     ta4tgl      trgsr.bit.b6   /* Timer A4 event/trigger select bit */

#define     ta4tgh      trgsr.bit.b7   /* Timer A4 event/trigger select bit */



/*------------------------------------------------------

    UART transmit/receive control register 2

------------------------------------------------------*/







#define     u0irs       ucon.bit.b0    /* UART0 transmit interrupt cause select bit */

#define     u1irs       ucon.bit.b1    /* UART1 transmit interrupt cause select bit */

#define     u0rrm       ucon.bit.b2    /* UART0 continuous receive mode enable bit */

#define     u1rrm       ucon.bit.b3    /* UART1 continuous receive mode enable bit */

#define     clkmd0      ucon.bit.b4    /* CLK/CLKS select bit 0 */

#define     clkmd1      ucon.bit.b5    /* CLK/CLKS select bit 1 */



/*------------------------------------------------------

    UART2 transmit/receive control register 1

------------------------------------------------------*/







#define     te_u2c1     u2c1.bit.b0    /* Transmit enable bit */

#define     ti_u2c1     u2c1.bit.b1    /* Transmit buffer empty flag */

#define     re_u2c1     u2c1.bit.b2    /* Receive enable bit */

#define     ri_u2c1     u2c1.bit.b3    /* Receive complete flag */

#define     u2irs       u2c1.bit.b4    /* UART2 transmit interrupt cause select bit */

#define     u2rrm       u2c1.bit.b5    /* UART2 continuous receive mode enable bit */

#define     u2lch       u2c1.bit.b6    /* Data logic select bit */

#define     u2ere       u2c1.bit.b7    /* Error signal output enable bit */



/*------------------------------------------------------

    UART2 special mode register 3

------------------------------------------------------*/







#define     dl0         u2smr3.bit.b5   /* SDA digital delay setup bit */

#define     dl1         u2smr3.bit.b6   /* SDA digital delay setup bit */

#define     dl2         u2smr3.bit.b7   /* SDA digital delay setup bit */



/*------------------------------------------------------

    UART2 special mode register 2

------------------------------------------------------*/







#define     iicm2       u2smr2.bit.b0  /* IIC mode selection bit 2 */

#define     csc         u2smr2.bit.b1  /* Clock-synchronous bit */

#define     swc         u2smr2.bit.b2  /* SCL wait output bit */

#define     als         u2smr2.bit.b3  /* SDA output stop bit */

#define     stac        u2smr2.bit.b4  /* UART2 initialization bit */

#define     swc2        u2smr2.bit.b5  /* SCL wait output bit 2 */

#define     sdhi        u2smr2.bit.b6  /* SDA output disable bit */

#define     shtc        u2smr2.bit.b7  /* Start/stop condition control bit */



/*------------------------------------------------------

    UART2 special mode register

------------------------------------------------------*/







#define     iicm        u2smr.bit.b0   /* IIC mode selection bit */

#define     abc         u2smr.bit.b1   /* Arbitration lost detecting flag control bit */

#define     bbs         u2smr.bit.b2   /* Bus busy flag */

#define     lsyn        u2smr.bit.b3   /* SCLL sync output enable bit */

#define     abscs       u2smr.bit.b4   /* Bus collision detect sampling clock select bit */

#define     acse        u2smr.bit.b5   /* Auto clear function select bit of transmit enable bit */

#define     sss         u2smr.bit.b6   /* Transmit start condition select bit */

#define     sdds        u2smr.bit.b7   /* SDA digital delay select bit */



/*------------------------------------------------------

    A/D control register 0

------------------------------------------------------*/







#define     ch0         adcon0.bit.b0  /* Analog input pin select bit */

#define     ch1         adcon0.bit.b1  /* Analog input pin select bit */

#define     ch2         adcon0.bit.b2  /* Analog input pin select bit */

#define     md0         adcon0.bit.b3  /* A/D operation mode select bit 0 */

#define     md1         adcon0.bit.b4  /* A/D operation mode select bit 0 */

#define     trg         adcon0.bit.b5  /* Trigger select bit */

#define     adst        adcon0.bit.b6  /* A/D conversion start flag */

#define     cks0        adcon0.bit.b7  /* Frequency select bit 0 */



/*------------------------------------------------------

    A/D control register 1

------------------------------------------------------*/







#define     scan0       adcon1.bit.b0  /* A/D sweep pin select bit */

#define     scan1       adcon1.bit.b1  /* A/D sweep pin select bit */

#define     md2         adcon1.bit.b2  /* A/D operation mode select bit 1 */

#define     bits        adcon1.bit.b3  /* 8/10-bit mode select bit */

#define     cks1        adcon1.bit.b4  /* Frequency select bit 1 */

#define     vcut        adcon1.bit.b5  /* Vref connect bit */

#define     opa0        adcon1.bit.b6  /* External op-amp connection mode bit */

#define     opa1        adcon1.bit.b7  /* External op-amp connection mode bit */



/*------------------------------------------------------

    A/D control register 2

------------------------------------------------------*/







#define     smp         adcon2.bit.b0  /* A/D conversion method select bit */



/*------------------------------------------------------

    D/A control register

------------------------------------------------------*/







#define     da0e        dacon.bit.b0   /* D/A0 output enable bit */

#define     da1e        dacon.bit.b1   /* D/A1 output enable bit */



/*------------------------------------------------------

    Port P0 register

------------------------------------------------------*/







#define     p0_0        p0.bit.b0      /* Port P00 register */

#define     p0_1        p0.bit.b1      /* Port P01 register */

#define     p0_2        p0.bit.b2      /* Port P02 register */

#define     p0_3        p0.bit.b3      /* Port P03 register */

#define     p0_4        p0.bit.b4      /* Port P04 register */

#define     p0_5        p0.bit.b5      /* Port P05 register */

#define     p0_6        p0.bit.b6      /* Port P06 register */

#define     p0_7        p0.bit.b7      /* Port P07 register */



/*------------------------------------------------------

    Port P0 direction register

------------------------------------------------------*/







#define     pd0_0       pd0.bit.b0     /* Port P00 direction register */

#define     pd0_1       pd0.bit.b1     /* Port P01 direction register */

#define     pd0_2       pd0.bit.b2     /* Port P02 direction register */

#define     pd0_3       pd0.bit.b3     /* Port P03 direction register */

#define     pd0_4       pd0.bit.b4     /* Port P04 direction register */

#define     pd0_5       pd0.bit.b5     /* Port P05 direction register */

#define     pd0_6       pd0.bit.b6     /* Port P06 direction register */

#define     pd0_7       pd0.bit.b7     /* Port P07 direction register */



/*------------------------------------------------------

    Port P1 register

------------------------------------------------------*/







#define     p1_0        p1.bit.b0      /* Port P10 register */

#define     p1_1        p1.bit.b1      /* Port P11 register */

#define     p1_2        p1.bit.b2      /* Port P12 register */

#define     p1_3        p1.bit.b3      /* Port P13 register */

#define     p1_4        p1.bit.b4      /* Port P14 register */

#define     p1_5        p1.bit.b5      /* Port P15 register */

#define     p1_6        p1.bit.b6      /* Port P16 register */

#define     p1_7        p1.bit.b7      /* Port P17 register */



/*------------------------------------------------------

    Port P1 direction register

------------------------------------------------------*/







#define     pd1_0       pd1.bit.b0     /* Port P10 direction register */

#define     pd1_1       pd1.bit.b1     /* Port P11 direction register */

#define     pd1_2       pd1.bit.b2     /* Port P12 direction register */

#define     pd1_3       pd1.bit.b3     /* Port P13 direction register */

#define     pd1_4       pd1.bit.b4     /* Port P14 direction register */

#define     pd1_5       pd1.bit.b5     /* Port P15 direction register */

#define     pd1_6       pd1.bit.b6     /* Port P16 direction register */

#define     pd1_7       pd1.bit.b7     /* Port P17 direction register */



/*------------------------------------------------------

    Port P2 register

------------------------------------------------------*/







#define     p2_0        p2.bit.b0      /* Port P20 register */

#define     p2_1        p2.bit.b1      /* Port P21 register */

#define     p2_2        p2.bit.b2      /* Port P22 register */

#define     p2_3        p2.bit.b3      /* Port P23 register */

#define     p2_4        p2.bit.b4      /* Port P24 register */

#define     p2_5        p2.bit.b5      /* Port P25 register */

#define     p2_6        p2.bit.b6      /* Port P26 register */

#define     p2_7        p2.bit.b7      /* Port P27 register */



/*------------------------------------------------------

    Port P2 direction register

------------------------------------------------------*/







#define     pd2_0       pd2.bit.b0     /* Port P20 direction register */

#define     pd2_1       pd2.bit.b1     /* Port P21 direction register */

#define     pd2_2       pd2.bit.b2     /* Port P22 direction register */

#define     pd2_3       pd2.bit.b3     /* Port P23 direction register */

#define     pd2_4       pd2.bit.b4     /* Port P24 direction register */

#define     pd2_5       pd2.bit.b5     /* Port P25 direction register */

#define     pd2_6       pd2.bit.b6     /* Port P26 direction register */

#define     pd2_7       pd2.bit.b7     /* Port P27 direction register */



/*------------------------------------------------------

    Port P3 register

------------------------------------------------------*/







#define     p3_0        p3.bit.b0      /* Port P30 register */

#define     p3_1        p3.bit.b1      /* Port P31 register */

#define     p3_2        p3.bit.b2      /* Port P32 register */

#define     p3_3        p3.bit.b3      /* Port P33 register */

#define     p3_4        p3.bit.b4      /* Port P34 register */

#define     p3_5        p3.bit.b5      /* Port P35 register */

#define     p3_6        p3.bit.b6      /* Port P36 register */

#define     p3_7        p3.bit.b7      /* Port P37 register */



/*------------------------------------------------------

    Port P3 direction register

------------------------------------------------------*/







#define     pd3_0       pd3.bit.b0     /* Port P30 direction register */

#define     pd3_1       pd3.bit.b1     /* Port P31 direction register */

#define     pd3_2       pd3.bit.b2     /* Port P32 direction register */

#define     pd3_3       pd3.bit.b3     /* Port P33 direction register */

#define     pd3_4       pd3.bit.b4     /* Port P34 direction register */

#define     pd3_5       pd3.bit.b5     /* Port P35 direction register */

#define     pd3_6       pd3.bit.b6     /* Port P36 direction register */

#define     pd3_7       pd3.bit.b7     /* Port P37 direction register */



/*------------------------------------------------------

    Port P4 register

------------------------------------------------------*/







#define     p4_0        p4.bit.b0      /* Port P40 register */

#define     p4_1        p4.bit.b1      /* Port P41 register */

#define     p4_2        p4.bit.b2      /* Port P42 register */

#define     p4_3        p4.bit.b3      /* Port P43 register */

#define     p4_4        p4.bit.b4      /* Port P44 register */

#define     p4_5        p4.bit.b5      /* Port P45 register */

#define     p4_6        p4.bit.b6      /* Port P46 register */

#define     p4_7        p4.bit.b7      /* Port P47 register */



/*------------------------------------------------------

    Port P4 direction register

------------------------------------------------------*/







#define     pd4_0       pd4.bit.b0     /* Port P40 direction register */

#define     pd4_1       pd4.bit.b1     /* Port P41 direction register */

#define     pd4_2       pd4.bit.b2     /* Port P42 direction register */

#define     pd4_3       pd4.bit.b3     /* Port P43 direction register */

#define     pd4_4       pd4.bit.b4     /* Port P44 direction register */

#define     pd4_5       pd4.bit.b5     /* Port P45 direction register */

#define     pd4_6       pd4.bit.b6     /* Port P46 direction register */

#define     pd4_7       pd4.bit.b7     /* Port P47 direction register */



/*------------------------------------------------------

    Port P5 register

------------------------------------------------------*/







#define     p5_0        p5.bit.b0      /* Port P50 register */

#define     p5_1        p5.bit.b1      /* Port P51 register */

#define     p5_2        p5.bit.b2      /* Port P52 register */

#define     p5_3        p5.bit.b3      /* Port P53 register */

#define     p5_4        p5.bit.b4      /* Port P54 register */

#define     p5_5        p5.bit.b5      /* Port P55 register */

#define     p5_6        p5.bit.b6      /* Port P56 register */

#define     p5_7        p5.bit.b7      /* Port P57 register */



/*------------------------------------------------------

    Port P5 direction register

------------------------------------------------------*/







#define     pd5_0       pd5.bit.b0     /* Port P50 direction register */

#define     pd5_1       pd5.bit.b1     /* Port P51 direction register */

#define     pd5_2       pd5.bit.b2     /* Port P52 direction register */

#define     pd5_3       pd5.bit.b3     /* Port P53 direction register */

#define     pd5_4       pd5.bit.b4     /* Port P54 direction register */

#define     pd5_5       pd5.bit.b5     /* Port P55 direction register */

#define     pd5_6       pd5.bit.b6     /* Port P56 direction register */

#define     pd5_7       pd5.bit.b7     /* Port P57 direction register */



/*------------------------------------------------------

    Port P6 register

------------------------------------------------------*/







#define     p6_0        p6.bit.b0      /* Port P60 register */

#define     p6_1        p6.bit.b1      /* Port P61 register */

#define     p6_2        p6.bit.b2      /* Port P62 register */

#define     p6_3        p6.bit.b3      /* Port P63 register */

#define     p6_4        p6.bit.b4      /* Port P64 register */

#define     p6_5        p6.bit.b5      /* Port P65 register */

#define     p6_6        p6.bit.b6      /* Port P66 register */

#define     p6_7        p6.bit.b7      /* Port P67 register */



/*------------------------------------------------------

    Port P6 direction register

------------------------------------------------------*/







#define     pd6_0       pd6.bit.b0     /* Port P60 direction register */

#define     pd6_1       pd6.bit.b1     /* Port P61 direction register */

#define     pd6_2       pd6.bit.b2     /* Port P62 direction register */

#define     pd6_3       pd6.bit.b3     /* Port P63 direction register */

#define     pd6_4       pd6.bit.b4     /* Port P64 direction register */

#define     pd6_5       pd6.bit.b5     /* Port P65 direction register */

#define     pd6_6       pd6.bit.b6     /* Port P66 direction register */

#define     pd6_7       pd6.bit.b7     /* Port P67 direction register */



/*------------------------------------------------------

    Port P7 register

------------------------------------------------------*/







#define     p7_0        p7.bit.b0      /* Port P70 register */

#define     p7_1        p7.bit.b1      /* Port P71 register */

#define     p7_2        p7.bit.b2      /* Port P72 register */

#define     p7_3        p7.bit.b3      /* Port P73 register */

#define     p7_4        p7.bit.b4      /* Port P74 register */

#define     p7_5        p7.bit.b5      /* Port P75 register */

#define     p7_6        p7.bit.b6      /* Port P76 register */

#define     p7_7        p7.bit.b7      /* Port P77 register */



/*------------------------------------------------------

    Port P7 direction register

------------------------------------------------------*/







#define     pd7_0       pd7.bit.b0     /* Port P70 direction register */

#define     pd7_1       pd7.bit.b1     /* Port P71 direction register */

#define     pd7_2       pd7.bit.b2     /* Port P72 direction register */

#define     pd7_3       pd7.bit.b3     /* Port P73 direction register */

#define     pd7_4       pd7.bit.b4     /* Port P74 direction register */

#define     pd7_5       pd7.bit.b5     /* Port P75 direction register */

#define     pd7_6       pd7.bit.b6     /* Port P76 direction register */

#define     pd7_7       pd7.bit.b7     /* Port P77 direction register */



/*------------------------------------------------------

    Port P8 register

------------------------------------------------------*/







#define     p8_0        p8.bit.b0      /* Port P80 register */

#define     p8_1        p8.bit.b1      /* Port P81 register */

#define     p8_2        p8.bit.b2      /* Port P82 register */

#define     p8_3        p8.bit.b3      /* Port P83 register */

#define     p8_4        p8.bit.b4      /* Port P84 register */

#define     p8_5        p8.bit.b5      /* Port P85 register */

#define     p8_6        p8.bit.b6      /* Port P86 register */

#define     p8_7        p8.bit.b7      /* Port P87 register */



/*------------------------------------------------------

    Port P8 direction register

------------------------------------------------------*/







#define     pd8_0       pd8.bit.b0     /* Port P80 direction register */

#define     pd8_1       pd8.bit.b1     /* Port P81 direction register */

#define     pd8_2       pd8.bit.b2     /* Port P82 direction register */

#define     pd8_3       pd8.bit.b3     /* Port P83 direction register */

#define     pd8_4       pd8.bit.b4     /* Port P84 direction register */

#define     pd8_6       pd8.bit.b6     /* Port P86 direction register */

#define     pd8_7       pd8.bit.b7     /* Port P87 direction register */



/*------------------------------------------------------

    Port P9 register

------------------------------------------------------*/







#define     p9_0        p9.bit.b0      /* Port P90 register */

#define     p9_1        p9.bit.b1      /* Port P91 register */

#define     p9_2        p9.bit.b2      /* Port P92 register */

#define     p9_3        p9.bit.b3      /* Port P93 register */

#define     p9_4        p9.bit.b4      /* Port P94 register */

#define     p9_5        p9.bit.b5      /* Port P95 register */

#define     p9_6        p9.bit.b6      /* Port P96 register */

#define     p9_7        p9.bit.b7      /* Port P97 register */



/*------------------------------------------------------

    Port P9 direction register

------------------------------------------------------*/







#define     pd9_0       pd9.bit.b0     /* Port P90 direction register */

#define     pd9_1       pd9.bit.b1     /* Port P91 direction register */

#define     pd9_2       pd9.bit.b2     /* Port P92 direction register */

#define     pd9_3       pd9.bit.b3     /* Port P93 direction register */

#define     pd9_4       pd9.bit.b4     /* Port P94 direction register */

#define     pd9_5       pd9.bit.b5     /* Port P95 direction register */

#define     pd9_6       pd9.bit.b6     /* Port P96 direction register */

#define     pd9_7       pd9.bit.b7     /* Port P97 direction register */



/*------------------------------------------------------

    Port P10 register

------------------------------------------------------*/







#define     p10_0       p10.bit.b0     /* Port P100 register */

#define     p10_1       p10.bit.b1     /* Port P101 register */

#define     p10_2       p10.bit.b2     /* Port P102 register */

#define     p10_3       p10.bit.b3     /* Port P103 register */

#define     p10_4       p10.bit.b4     /* Port P104 register */

#define     p10_5       p10.bit.b5     /* Port P105 register */

#define     p10_6       p10.bit.b6     /* Port P106 register */

#define     p10_7       p10.bit.b7     /* Port P107 register */



/*------------------------------------------------------

    Port P10 direction register

------------------------------------------------------*/







#define     pd10_0      pd10.bit.b0    /* Port P100 direction register */

#define     pd10_1      pd10.bit.b1    /* Port P101 direction register */

#define     pd10_2      pd10.bit.b2    /* Port P102 direction register */

#define     pd10_3      pd10.bit.b3    /* Port P103 direction register */

#define     pd10_4      pd10.bit.b4    /* Port P104 direction register */

#define     pd10_5      pd10.bit.b5    /* Port P105 direction register */

#define     pd10_6      pd10.bit.b6    /* Port P106 direction register */

#define     pd10_7      pd10.bit.b7    /* Port P107 direction register */



/*------------------------------------------------------

    Pull-up control register 0

------------------------------------------------------*/







#define     pu00        pur0.bit.b0    /* P00 to P03 pull-up */

#define     pu01        pur0.bit.b1    /* P04 to P07 pull-up */

#define     pu02        pur0.bit.b2    /* P10 to P13 pull-up */

#define     pu03        pur0.bit.b3    /* P14 to P17 pull-up */

#define     pu04        pur0.bit.b4    /* P20 to P23 pull-up */

#define     pu05        pur0.bit.b5    /* P24 to P27 pull-up */

#define     pu06        pur0.bit.b6    /* P30 to P33 pull-up */

#define     pu07        pur0.bit.b7    /* P34 to P37 pull-up */



/*------------------------------------------------------

    Pull-up control register 1

------------------------------------------------------*/







#define     pu10        pur1.bit.b0    /* P40 to P43 pull-up */

#define     pu11        pur1.bit.b1    /* P44 to P47 pull-up */

#define     pu12        pur1.bit.b2    /* P50 to P53 pull-up */

#define     pu13        pur1.bit.b3    /* P54 to P57 pull-up */

#define     pu14        pur1.bit.b4    /* P60 to P63 pull-up */

#define     pu15        pur1.bit.b5    /* P64 to P67 pull-up */

#define     pu16        pur1.bit.b6    /* P70 to P73 pull-up (Except P70,P71 ; P70,P71 -> N-channel open drain ports)*/

#define     pu17        pur1.bit.b7    /* P74 to P77 pull-up */



/*------------------------------------------------------

    Pull-up control register 2

------------------------------------------------------*/







#define     pu20        pur2.bit.b0    /* P80 to P83 pull-up */

#define     pu21        pur2.bit.b1    /* P84 to P87 pull-up (Except P85) */

#define     pu22        pur2.bit.b2    /* P90 to P93 pull-up */

#define     pu23        pur2.bit.b3    /* P94 to P97 pull-up */

#define     pu24        pur2.bit.b4    /* P100 to P103 pull-up */

#define     pu25        pur2.bit.b5    /* P104 to P107 pull-up */



/*------------------------------------------------------

    Port control register

------------------------------------------------------*/







#define     pcr0        pcr.bit.b0     /* Port P1 control register */



/*------------------------------------------------------

    UARTi bit rate generators (i=0 to 2) ; Use "MOV" instruction when writing to these registers.

------------------------------------------------------*/




















/*------------------------------------------------------

    SI/Oi bit rate generators (i=3,4) ; Use "MOV" instruction when writing to these registers.

------------------------------------------------------*/













/*------------------------------------------------------

    SI/Oi transmit/receive registers (i=3,4)

------------------------------------------------------*/













/********************************************************

*   declare SFR union                                   *

********************************************************/



/*------------------------------------------------------

    DMAi control register union

------------------------------------------------------*/

union dmicon{

    struct{

        char    dmbit:1;            /* Transfer unit bit select bit */

        char    dmasl:1;            /* Repeat transfer mode select bit */

        char    dmas:1;             /* DMA request bit */

        char    dmae:1;             /* DMA enable bit */

        char    dsd:1;              /* Source address direction select bit */

        char    dad:1;              /* Destination address direction select bit */

        char    b6:1;

        char    b7:1;

    }bit;

    char    byte;

} ;

/*------------------------------------------------------

     dm0con

------------------------------------------------------*/





#define     dmbit_dm0con    dm0con.bit.dmbit   /* Transfer unit bit select bit */

#define     dmasl_dm0con    dm0con.bit.dmasl   /* Repeat transfer mode select bit */

#define     dmas_dm0con     dm0con.bit.dmas    /* DMA request bit */

#define     dmae_dm0con     dm0con.bit.dmae    /* DMA enable bit */

#define     dsd_dm0con      dm0con.bit.dsd     /* Source address direction select bit */

#define     dad_dm0con      dm0con.bit.dad     /* Destination address direction select bit */



/*------------------------------------------------------

     dm1con

------------------------------------------------------*/





#define     dmbit_dm1con    dm1con.bit.dmbit   /* Transfer unit bit select bit */

#define     dmasl_dm1con    dm1con.bit.dmasl   /* Repeat transfer mode select bit */

#define     dmas_dm1con     dm1con.bit.dmas    /* DMA request bit */

#define     dmae_dm1con     dm1con.bit.dmae    /* DMA enable bit */

#define     dsd_dm1con      dm1con.bit.dsd     /* Source address direction select bit */

#define     dad_dm1con      dm1con.bit.dad     /* Destination address direction select bit */



/*------------------------------------------------------

    interrupt control registers

------------------------------------------------------*/

union intcr{

    struct{

        char    ilvl0:1;            /* Interrupt priority level select bit */

        char    ilvl1:1;            /* Interrupt priority level select bit */

        char    ilvl2:1;            /* Interrupt priority level select bit */

        char    ir:1;               /* Interrupt request bit */

        char    pol:1;              /* Polarity select bit */

        char    lvs:1;

        char    b6:1;

        char    b7:1;

    }bit;

    char    byte;

} ;



/*------------------------------------------------------

     bcnic

------------------------------------------------------*/





#define     ilvl0_bcnic bcnic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_bcnic bcnic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_bcnic bcnic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_bcnic    bcnic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     dm0ic

------------------------------------------------------*/





#define     ilvl0_dm0ic dm0ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_dm0ic dm0ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_dm0ic dm0ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_dm0ic    dm0ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     dm1ic

------------------------------------------------------*/





#define     ilvl0_dm1ic dm1ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_dm1ic dm1ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_dm1ic dm1ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_dm1ic    dm1ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     kupic

------------------------------------------------------*/





#define     ilvl0_kupic kupic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_kupic kupic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_kupic kupic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_kupic    kupic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     adic

------------------------------------------------------*/





#define     ilvl0_adic  adic.bit.ilvl0     /* Interrupt priority level select bit */

#define     ilvl1_adic  adic.bit.ilvl1     /* Interrupt priority level select bit */

#define     ilvl2_adic  adic.bit.ilvl2     /* Interrupt priority level select bit */

#define     ir_adic     adic.bit.ir        /* Interrupt request bit */



/*------------------------------------------------------

     s2tic

------------------------------------------------------*/





#define     ilvl0_s2tic s2tic.bit.ilvl0     /* Interrupt priority level select bit */

#define     ilvl1_s2tic s2tic.bit.ilvl1     /* Interrupt priority level select bit */

#define     ilvl2_s2tic s2tic.bit.ilvl2     /* Interrupt priority level select bit */

#define     ir_s2tic    s2tic.bit.ir        /* Interrupt request bit */



/*------------------------------------------------------

     s2ric

------------------------------------------------------*/





#define     ilvl0_s2ric s2ric.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_s2ric s2ric.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_s2ric s2ric.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_s2ric    s2ric.bit.ir       /* Interrupt request bit */





/*------------------------------------------------------

     s0tic

------------------------------------------------------*/





#define     ilvl0_s0tic s0tic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_s0tic s0tic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_s0tic s0tic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_s0tic    s0tic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     s0ric

------------------------------------------------------*/





#define     ilvl0_s0ric s0ric.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_s0ric s0ric.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_s0ric s0ric.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_s0ric    s0ric.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     s1tic

------------------------------------------------------*/





#define     ilvl0_s1tic s1tic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_s1tic s1tic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_s1tic s1tic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_s1tic    s1tic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     s1ric

------------------------------------------------------*/





#define     ilvl0_s1ric s1ric.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_s1ric s1ric.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_s1ric s1ric.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_s1ric    s1ric.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     s3ic

------------------------------------------------------*/





#define     ilvl0_s3ic  s3ic.bit.ilvl0     /* Interrupt priority level select bit */

#define     ilvl1_s3ic  s3ic.bit.ilvl1     /* Interrupt priority level select bit */

#define     ilvl2_s3ic  s3ic.bit.ilvl2     /* Interrupt priority level select bit */

#define     ir_s3ic     s3ic.bit.ir        /* Interrupt request bit */

#define     pol_s3ic    s3ic.bit.pol       /* Polarity select bit */



/*------------------------------------------------------

     s4ic

------------------------------------------------------*/





#define     ilvl0_s4ic  s4ic.bit.ilvl0     /* Interrupt priority level select bit */

#define     ilvl1_s4ic  s4ic.bit.ilvl1     /* Interrupt priority level select bit */

#define     ilvl2_s4ic  s4ic.bit.ilvl2     /* Interrupt priority level select bit */

#define     ir_s4ic     s4ic.bit.ir        /* Interrupt request bit */

#define     pol_s4ic    s4ic.bit.pol       /* Polarity select bit */



/*------------------------------------------------------

     ta0ic

------------------------------------------------------*/





#define     ilvl0_ta0ic ta0ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_ta0ic ta0ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_ta0ic ta0ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_ta0ic    ta0ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     ta1ic

------------------------------------------------------*/





#define     ilvl0_ta1ic ta1ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_ta1ic ta1ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_ta1ic ta1ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_ta1ic    ta1ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     ta2ic

------------------------------------------------------*/





#define     ilvl0_ta2ic ta2ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_ta2ic ta2ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_ta2ic ta2ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_ta2ic    ta2ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     ta3ic

------------------------------------------------------*/





#define     ilvl0_ta3ic ta3ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_ta3ic ta3ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_ta3ic ta3ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_ta3ic    ta3ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     ta4ic

------------------------------------------------------*/





#define     ilvl0_ta4ic ta4ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_ta4ic ta4ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_ta4ic ta4ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_ta4ic    ta4ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     tb0ic

------------------------------------------------------*/





#define     ilvl0_tb0ic tb0ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_tb0ic tb0ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_tb0ic tb0ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_tb0ic    tb0ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     tb1ic

------------------------------------------------------*/





#define     ilvl0_tb1ic tb1ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_tb1ic tb1ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_tb1ic tb1ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_tb1ic    tb1ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     tb2ic

------------------------------------------------------*/





#define     ilvl0_tb2ic tb2ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_tb2ic tb2ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_tb2ic tb2ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_tb2ic    tb2ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     tb3ic

------------------------------------------------------*/





#define     ilvl0_tb3ic tb3ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_tb3ic tb3ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_tb3ic tb3ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_tb3ic    tb3ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     tb4ic

------------------------------------------------------*/





#define     ilvl0_tb4ic tb4ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_tb4ic tb4ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_tb4ic tb4ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_tb4ic    tb4ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     tb5ic

------------------------------------------------------*/





#define     ilvl0_tb5ic tb5ic.bit.ilvl0    /* Interrupt priority level select bit */

#define     ilvl1_tb5ic tb5ic.bit.ilvl1    /* Interrupt priority level select bit */

#define     ilvl2_tb5ic tb5ic.bit.ilvl2    /* Interrupt priority level select bit */

#define     ir_tb5ic    tb5ic.bit.ir       /* Interrupt request bit */



/*------------------------------------------------------

     int5ic

------------------------------------------------------*/





#define     ilvl0_int5ic    int5ic.bit.ilvl0  /* Interrupt priority level select bit */

#define     ilvl1_int5ic    int5ic.bit.ilvl1  /* Interrupt priority level select bit */

#define     ilvl2_int5ic    int5ic.bit.ilvl2  /* Interrupt priority level select bit */

#define     ir_int5ic       int5ic.bit.ir     /* Interrupt request bit */

#define     pol_int5ic      int5ic.bit.pol    /* Polarity select bit */



/*------------------------------------------------------

     int4ic

------------------------------------------------------*/





#define     ilvl0_int4ic    int4ic.bit.ilvl0  /* Interrupt priority level select bit */

#define     ilvl1_int4ic    int4ic.bit.ilvl1  /* Interrupt priority level select bit */

#define     ilvl2_int4ic    int4ic.bit.ilvl2  /* Interrupt priority level select bit */

#define     ir_int4ic       int4ic.bit.ir     /* Interrupt request bit */

#define     pol_int4ic      int4ic.bit.pol    /* Polarity select bit */



/*------------------------------------------------------

     int0ic

------------------------------------------------------*/





#define     ilvl0_int0ic    int0ic.bit.ilvl0  /* Interrupt priority level select bit */

#define     ilvl1_int0ic    int0ic.bit.ilvl1  /* Interrupt priority level select bit */

#define     ilvl2_int0ic    int0ic.bit.ilvl2  /* Interrupt priority level select bit */

#define     ir_int0ic       int0ic.bit.ir     /* Interrupt request bit */

#define     pol_int0ic      int0ic.bit.pol    /* Polarity select bit */



/*------------------------------------------------------

     int1ic

------------------------------------------------------*/





#define     ilvl0_int1ic    int1ic.bit.ilvl0  /* Interrupt priority level select bit */

#define     ilvl1_int1ic    int1ic.bit.ilvl1  /* Interrupt priority level select bit */

#define     ilvl2_int1ic    int1ic.bit.ilvl2  /* Interrupt priority level select bit */

#define     ir_int1ic       int1ic.bit.ir     /* Interrupt request bit */

#define     pol_int1ic      int1ic.bit.pol    /* Polarity select bit */



/*------------------------------------------------------

     int2ic

------------------------------------------------------*/





#define     ilvl0_int2ic    int2ic.bit.ilvl0  /* Interrupt priority level select bit */

#define     ilvl1_int2ic    int2ic.bit.ilvl1  /* Interrupt priority level select bit */

#define     ilvl2_int2ic    int2ic.bit.ilvl2  /* Interrupt priority level select bit */

#define     ir_int2ic       int2ic.bit.ir     /* Interrupt request bit */

#define     pol_int2ic      int2ic.bit.pol    /* Polarity select bit */



/*------------------------------------------------------

     int3ic

------------------------------------------------------*/





#define     ilvl0_int3ic    int3ic.bit.ilvl0  /* Interrupt priority level select bit */

#define     ilvl1_int3ic    int3ic.bit.ilvl1  /* Interrupt priority level select bit */

#define     ilvl2_int3ic    int3ic.bit.ilvl2  /* Interrupt priority level select bit */

#define     ir_int3ic       int3ic.bit.ir     /* Interrupt request bit */

#define     pol_int3ic      int3ic.bit.pol    /* Polarity select bit */



/*------------------------------------------------------

    Timer mode registers

------------------------------------------------------*/

union timr{

    struct{

        char    tmod0:1;            /* Operation mode select bit */

        char    tmod1:1;            /* Operation mode select bit */

        char    mr0:1;

        char    mr1:1;

        char    mr2:1;

        char    mr3:1;

        char    tck0:1;             /* Count source select bit */

        char    tck1:1;             /* Count source select bit */

    }bit;

    char    byte;

} ;



/*------------------------------------------------------

     ta0mr

------------------------------------------------------*/





#define     tmod0_ta0mr ta0mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_ta0mr ta0mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_ta0mr   ta0mr.bit.mr0

#define     mr1_ta0mr   ta0mr.bit.mr1

#define     mr2_ta0mr   ta0mr.bit.mr2

#define     mr3_ta0mr   ta0mr.bit.mr3

#define     tck0_ta0mr  ta0mr.bit.tck0         /* Count source select bit */

#define     tck1_ta0mr  ta0mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     ta1mr

------------------------------------------------------*/





#define     tmod0_ta1mr ta1mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_ta1mr ta1mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_ta1mr   ta1mr.bit.mr0

#define     mr1_ta1mr   ta1mr.bit.mr1

#define     mr2_ta1mr   ta1mr.bit.mr2

#define     mr3_ta1mr   ta1mr.bit.mr3

#define     tck0_ta1mr  ta1mr.bit.tck0         /* Count source select bit */

#define     tck1_ta1mr  ta1mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     ta2mr

------------------------------------------------------*/





#define     tmod0_ta2mr ta2mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_ta2mr ta2mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_ta2mr   ta2mr.bit.mr0

#define     mr1_ta2mr   ta2mr.bit.mr1

#define     mr2_ta2mr   ta2mr.bit.mr2

#define     mr3_ta2mr   ta2mr.bit.mr3

#define     tck0_ta2mr  ta2mr.bit.tck0         /* Count source select bit */

#define     tck1_ta2mr  ta2mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     ta3mr

------------------------------------------------------*/





#define     tmod0_ta3mr ta3mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_ta3mr ta3mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_ta3mr   ta3mr.bit.mr0

#define     mr1_ta3mr   ta3mr.bit.mr1

#define     mr2_ta3mr   ta3mr.bit.mr2

#define     mr3_ta3mr   ta3mr.bit.mr3

#define     tck0_ta3mr  ta3mr.bit.tck0         /* Count source select bit */

#define     tck1_ta3mr  ta3mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     ta4mr

------------------------------------------------------*/





#define     tmod0_ta4mr ta4mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_ta4mr ta4mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_ta4mr   ta4mr.bit.mr0

#define     mr1_ta4mr   ta4mr.bit.mr1

#define     mr2_ta4mr   ta4mr.bit.mr2

#define     mr3_ta4mr   ta4mr.bit.mr3

#define     tck0_ta4mr  ta4mr.bit.tck0         /* Count source select bit */

#define     tck1_ta4mr  ta4mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     tb0mr

 ------------------------------------------------------*/





#define     tmod0_tb0mr tb0mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_tb0mr tb0mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_tb0mr   tb0mr.bit.mr0

#define     mr1_tb0mr   tb0mr.bit.mr1

#define     mr2_tb0mr   tb0mr.bit.mr2

#define     mr3_tb0mr   tb0mr.bit.mr3

#define     tck0_tb0mr  tb0mr.bit.tck0         /* Count source select bit */

#define     tck1_tb0mr  tb0mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     tb1mr

------------------------------------------------------*/





#define     tmod0_tb1mr tb1mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_tb1mr tb1mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_tb1mr   tb1mr.bit.mr0

#define     mr1_tb1mr   tb1mr.bit.mr1

#define     mr3_tb1mr   tb1mr.bit.mr3

#define     tck0_tb1mr  tb1mr.bit.tck0         /* Count source select bit */

#define     tck1_tb1mr  tb1mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     tb2mr

------------------------------------------------------*/





#define     tmod0_tb2mr tb2mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_tb2mr tb2mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_tb2mr   tb2mr.bit.mr0

#define     mr1_tb2mr   tb2mr.bit.mr1

#define     mr3_tb2mr   tb2mr.bit.mr3

#define     tck0_tb2mr  tb2mr.bit.tck0         /* Count source select bit */

#define     tck1_tb2mr  tb2mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     tb3mr

------------------------------------------------------*/





#define     tmod0_tb3mr tb3mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_tb3mr tb3mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_tb3mr   tb3mr.bit.mr0

#define     mr1_tb3mr   tb3mr.bit.mr1

#define     mr2_tb3mr   tb3mr.bit.mr2

#define     mr3_tb3mr   tb3mr.bit.mr3

#define     tck0_tb3mr  tb3mr.bit.tck0         /* Count source select bit */

#define     tck1_tb3mr  tb3mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     tb4mr

------------------------------------------------------*/





#define     tmod0_tb4mr tb4mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_tb4mr tb4mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_tb4mr   tb4mr.bit.mr0

#define     mr1_tb4mr   tb4mr.bit.mr1

#define     mr3_tb4mr   tb4mr.bit.mr3

#define     tck0_tb4mr  tb4mr.bit.tck0         /* Count source select bit */

#define     tck1_tb4mr  tb4mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     tb5mr

------------------------------------------------------*/





#define     tmod0_tb5mr tb5mr.bit.tmod0        /* Operation mode select bit */

#define     tmod1_tb5mr tb5mr.bit.tmod1        /* Operation mode select bit */

#define     mr0_tb5mr   tb5mr.bit.mr0

#define     mr1_tb5mr   tb5mr.bit.mr1

#define     mr3_tb5mr   tb5mr.bit.mr3

#define     tck0_tb5mr  tb5mr.bit.tck0         /* Count source select bit */

#define     tck1_tb5mr  tb5mr.bit.tck1         /* Count source select bit */



/*------------------------------------------------------

     ifsr

------------------------------------------------------*/







#define     ifsr0       ifsr.bit.b0        /* INT0~ interrupt polarity switching bit */

#define     ifsr1       ifsr.bit.b1        /* INT1~ interrupt polarity switching bit */

#define     ifsr2       ifsr.bit.b2        /* INT2~ interrupt polarity switching bit */

#define     ifsr3       ifsr.bit.b3        /* INT3~ interrupt polarity switching bit */

#define     ifsr4       ifsr.bit.b4        /* INT4~ interrupt polarity switching bit */

#define     ifsr5       ifsr.bit.b5        /* INT5~ interrupt polarity switching bit */

#define     ifsr6       ifsr.bit.b6        /* Interrupt request cause select bit */

#define     ifsr7       ifsr.bit.b7        /* Interrupt request cause select bit */



/*------------------------------------------------------

    UARTi transmit/receive mode register

------------------------------------------------------*/

union uimr{

    struct{

        char    smd0:1;             /* Serial I/O mode select bit */

        char    smd1:1;             /* Serial I/O mode select bit */

        char    smd2:1;             /* Serial I/O mode select bit */

        char    ckdir:1;            /* Internal/external clock select bit */

        char    stps:1;             /* Stop bit length select bit */

        char    pry:1;              /* Odd/even parity select bit */

        char    prye:1;             /* Parity enable bit */

        char    slep:1;             /* Sleep select bit */

    }bit;

    char    byte;

};



/*------------------------------------------------------

     u0mr

------------------------------------------------------*/





#define     smd0_u0mr   u0mr.bit.smd0           /* Serial I/O mode select bit */

#define     smd1_u0mr   u0mr.bit.smd1           /* Serial I/O mode select bit */

#define     smd2_u0mr   u0mr.bit.smd2           /* Serial I/O mode select bit */

#define     ckdir_u0mr  u0mr.bit.ckdir          /* Internal/external clock select bit */

#define     stps_u0mr   u0mr.bit.stps           /* Stop bit length select bit */

#define     pry_u0mr    u0mr.bit.pry            /* Odd/even parity select bit */

#define     prye_u0mr   u0mr.bit.prye           /* Parity enable bit */

#define     slep_u0mr   u0mr.bit.slep           /* Sleep select bit */



/*------------------------------------------------------

     u1mr

------------------------------------------------------*/





#define     smd0_u1mr   u1mr.bit.smd0          /* Serial I/O mode select bit */

#define     smd1_u1mr   u1mr.bit.smd1          /* Serial I/O mode select bit */

#define     smd2_u1mr   u1mr.bit.smd2          /* Serial I/O mode select bit */

#define     ckdir_u1mr  u1mr.bit.ckdir         /* Internal/external clock select bit */

#define     stps_u1mr   u1mr.bit.stps          /* Stop bit length select bit */

#define     pry_u1mr    u1mr.bit.pry           /* Odd/even parity select bit */

#define     prye_u1mr   u1mr.bit.prye          /* Parity enable bit */

#define     slep_u1mr   u1mr.bit.slep          /* Sleep select bit */



/*------------------------------------------------------

     u2mr

------------------------------------------------------*/





#define     smd0_u2mr   u2mr.bit.smd0          /* Serial I/O mode select bit */

#define     smd1_u2mr   u2mr.bit.smd1          /* Serial I/O mode select bit */

#define     smd2_u2mr   u2mr.bit.smd2          /* Serial I/O mode select bit */

#define     ckdir_u2mr  u2mr.bit.ckdir         /* Internal/external clock select bit */

#define     stps_u2mr   u2mr.bit.stps          /* Stop bit length select bit */

#define     pry_u2mr    u2mr.bit.pry           /* Odd/even parity select bit */

#define     prye_u2mr   u2mr.bit.prye          /* Parity enable bit */

#define     iopol_u2mr  u2mr.bit.slep          /* TxD RxD I/O polarity reverse bit */



/*------------------------------------------------------

    UARTi transmit/receive control register 0

------------------------------------------------------*/

union uic0{

    struct{

        char    clk0:1;             /* BRG count source select bit */

        char    clk1:1;             /* BRG count source select bit */

        char    crs:1;              /* CTS~/RTS~ function select bit */

        char    txept:1;            /* Transmit register empty flag */

        char    crd:1;              /* CTS~/RTS~ disable bit */

        char    nch:1;              /* Data output select bit */

        char    ckpol:1;            /* CLK polarity select bit */

        char    uform:1;            /* Transfer format select bit */

    }bit;

    char    byte;

};



/*------------------------------------------------------

     u0c0

------------------------------------------------------*/





#define     clk0_u0c0   u0c0.bit.clk0          /* BRG count source select bit */

#define     clk1_u0c0   u0c0.bit.clk1          /* BRG count source select bit */

#define     crs_u0c0    u0c0.bit.crs           /* CTS~/RTS~ function select bit */

#define     txept_u0c0  u0c0.bit.txept         /* Transmit register empty flag */

#define     crd_u0c0    u0c0.bit.crd           /* CTS~/RTS~ disable bit */

#define     nch_u0c0    u0c0.bit.nch           /* Data output select bit */

#define     ckpol_u0c0  u0c0.bit.ckpol         /* CLK polarity select bit */

#define     uform_u0c0  u0c0.bit.uform         /* Transfer format select bit */



/*------------------------------------------------------

     u1c0

------------------------------------------------------*/





#define     clk0_u1c0   u1c0.bit.clk0          /* BRG count source select bit */

#define     clk1_u1c0   u1c0.bit.clk1          /* BRG count source select bit */

#define     crs_u1c0    u1c0.bit.crs           /* CTS~/RTS~ function select bit */

#define     txept_u1c0  u1c0.bit.txept         /* Transmit register empty flag */

#define     crd_u1c0    u1c0.bit.crd           /* CTS~/RTS~ disable bit */

#define     nch_u1c0    u1c0.bit.nch           /* Data output select bit */

#define     ckpol_u1c0  u1c0.bit.ckpol         /* CLK polarity select bit */

#define     uform_u1c0  u1c0.bit.uform         /* Transfer format select bit */



/*------------------------------------------------------

     u2c0

------------------------------------------------------*/





#define     clk0_u2c0   u2c0.bit.clk0          /* BRG count source select bit */

#define     clk1_u2c0   u2c0.bit.clk1          /* BRG count source select bit */

#define     crs_u2c0    u2c0.bit.crs           /* CTS~/RTS~ function select bit */

#define     txept_u2c0  u2c0.bit.txept         /* Transmit register empty flag */

#define     crd_u2c0    u2c0.bit.crd           /* CTS~/RTS~ disable bit */

#define     ckpol_u2c0  u2c0.bit.ckpol         /* CLK polarity select bit */

#define     uform_u2c0  u2c0.bit.uform         /* Transfer format select bit */



/*------------------------------------------------------

    UARTi transmit/receive control register 1

------------------------------------------------------*/

union uic1{

    struct{

        char    te:1;               /* Transmit enable bit */

        char    ti:1;               /* Transmit buffer empty flag */

        char    re:1;               /* Receive enable bit */

        char    ri:1;               /* Receive complete flag */

        char    b4:1;

        char    b5:1;

        char    b6:1;

        char    b7:1;

    }bit;

    char    byte;

} ;



/*------------------------------------------------------

     u0c1

------------------------------------------------------*/





#define     te_u0c1     u0c1.bit.te            /* Transmit enable bit */

#define     ti_u0c1     u0c1.bit.ti            /* Transmit buffer empty flag */

#define     re_u0c1     u0c1.bit.re            /* Receive enable bit */

#define     ri_u0c1     u0c1.bit.ri            /* Receive complete flag */



/*------------------------------------------------------

     u1c1

------------------------------------------------------*/





#define     te_u1c1     u1c1.bit.te            /* Transmit enable bit */

#define     ti_u1c1     u1c1.bit.ti            /* Transmit buffer empty flag */

#define     re_u1c1     u1c1.bit.re            /* Receive enable bit */

#define     ri_u1c1     u1c1.bit.ri            /* Receive complete flag */



/*------------------------------------------------------

    UARTi receive buffer registers

------------------------------------------------------*/

union uirb{

    struct{

        char    b0:1;

        char    b1:1;

        char    b2:1;

        char    b3:1;

        char    b4:1;

        char    b5:1;

        char    b6:1;

        char    b7:1;

        char    b8:1;

        char    b9:1;

        char    b10:1;

        char    abt:1;              /* Arbitration lost detecting flag */

        char    oer:1;              /* Overrun error flag */

        char    fer:1;              /* Framing error flag*/

        char    per:1;              /* Parity error flag */

        char    sum:1;              /* Error sum flag */

    }bit;

    struct{

        char    low;                /* Low  8 bit */

        char    high;               /* High 8 bit */

    }byte;

    unsigned short  word;

}u ;



/*------------------------------------------------------

     u0rb

------------------------------------------------------*/



#define     u0rbl       u0rb.byte.low

#define     u0rbh       u0rb.byte.high



#define     oer_u0rb    u0rb.bit.oer           /* Overrun error flag */

#define     fer_u0rb    u0rb.bit.fer           /* Framing error flag*/

#define     per_u0rb    u0rb.bit.per           /* Parity error flag */

#define     sum_u0rb    u0rb.bit.sum           /* Error sum flag */



/*------------------------------------------------------

     u1rb

------------------------------------------------------*/



#define     u1rbl       u1rb.byte.low

#define     u1rbh       u1rb.byte.high



#define     oer_u1rb    u1rb.bit.oer           /* Overrun error flag */

#define     fer_u1rb    u1rb.bit.fer           /* Framing error flag*/

#define     per_u1rb    u1rb.bit.per           /* Parity error flag */

#define     sum_u1rb    u1rb.bit.sum           /* Error sum flag */



/*------------------------------------------------------

     u2rb

------------------------------------------------------*/



#define     u2rbl       u2rb.byte.low

#define     u2rbh       u2rb.byte.high



#define     abt_u2rb    u2rb.bit.abt           /* Arbitration lost detecting flag */

#define     oer_u2rb    u2rb.bit.oer           /* Overrun error flag */

#define     fer_u2rb    u2rb.bit.fer           /* Framing error flag*/

#define     per_u2rb    u2rb.bit.per           /* Parity error flag */

#define     sum_u2rb    u2rb.bit.sum           /* Error sum flag */



/*------------------------------------------------------

    SI/O3,4 control registers

------------------------------------------------------*/

union sic{

    struct{

        char    smi0:1;

        char    smi1:1;

        char    smi2:1;

        char    smi3:1;

        char    smi4:1;

        char    smi5:1;

        char    smi6:1;

        char    smi7:1;

    }bit;

    char    byte;

} ;



/*------------------------------------------------------

     s3c

------------------------------------------------------*/





#define     sm30    s3c.bit.smi0           /* Internal synchronous clock select bit */

#define     sm31    s3c.bit.smi1           /* Internal synchronous clock select bit */

#define     sm32    s3c.bit.smi2           /* Sout3 output disable bit */

#define     sm33    s3c.bit.smi3           /* SI/O3 port select bit */

#define     sm35    s3c.bit.smi5           /* Transfer direction select bit */

#define     sm36    s3c.bit.smi6           /* Synchronous clock select bit */

#define     sm37    s3c.bit.smi7           /* Sout3 initial value set bit */



/*------------------------------------------------------

     s4c

------------------------------------------------------*/





#define     sm40    s4c.bit.smi0           /* Internal synchronous clock select bit */

#define     sm41    s4c.bit.smi1           /* Internal synchronous clock select bit */

#define     sm42    s4c.bit.smi2           /* Sout4 output disable bit */


#define     sm43    s4c.bit.smi3           /* SI/O4 port select bit */

#define     sm45    s4c.bit.smi5           /* Transfer direction select bit */

#define     sm46    s4c.bit.smi6           /* Synchronous clock select bit */

#define     sm47    s4c.bit.smi7           /* Sout4 initial value set bit */



/*------------------------------------------------------

    Flash memory control register 1

------------------------------------------------------*/

union fmr1_def{

    struct{

        char    b0:1;

        char    b1:1;

        char    b2:1;

        char    fmr13:1;        /* Flash memory power supply-OFF bit */

        char    b4:1;

        char    b5:1;

        char    b6:1;

        char    b7:1;

    }bit;

    char    byte;

} ;



/*------------------------------------------------------

     fmr1

------------------------------------------------------*/





#define     fmr13   fmr1.bit.fmr13             /* Flash memory power supply-OFF bit */



/*------------------------------------------------------

    Flash memory control register 0

------------------------------------------------------*/

union fmr0_def{

    struct{

        char    fmr00:1;            /* RY/BY~ status bit */

        char    fmr01:1;            /* CPU rewrite mode select bit */

        char    fmr02:1;            /* Lock bit disable bit */

        char    fmr03:1;            /* Flash memory reset bit */

        char    b4:1;

        char    fmr05:1;            /* User ROM area select bit */

        char    b6:1;

        char    b7:1;

    }bit;

    char    byte;

} ;



/*------------------------------------------------------

     fmr0

------------------------------------------------------*/





#define     fmr00   fmr0.bit.fmr00             /* RY/BY~ status bit */

#define     fmr01   fmr0.bit.fmr01             /* CPU rewrite mode select bit */

#define     fmr02   fmr0.bit.fmr02             /* Lock bit disable bit */

#define     fmr03   fmr0.bit.fmr03             /* Flash memory reset bit */

#define     fmr05   fmr0.bit.fmr05             /* User ROM area select bit */



/*------------------------------------------------------

    DMAi request cause select registers

------------------------------------------------------*/

union dmisl{

    struct{

        char    dsel0:1;            /* DMA request cause select bit */

        char    dsel1:1;            /* DMA request cause select bit */

        char    dsel2:1;            /* DMA request cause select bit */

        char    dsel3:1;            /* DMA request cause select bit */

        char    b4:1;

        char    b5:1;

        char    dms:1;              /* DMA request cause expansion bit */

        char    dsr:1;              /* Software DMA request bit */

    }bit;

    char    byte;

} ;



/*------------------------------------------------------

     dm0sl

------------------------------------------------------*/





#define     dsel0_dm0sl dm0sl.bit.dsel0        /* DMA request cause select bit */

#define     dsel1_dm0sl dm0sl.bit.dsel1        /* DMA request cause select bit */

#define     dsel2_dm0sl dm0sl.bit.dsel2        /* DMA request cause select bit */

#define     dsel3_dm0sl dm0sl.bit.dsel3        /* DMA request cause select bit */

#define     dms_dm0sl   dm0sl.bit.dms          /* DMA request cause expansion bit */

#define     dsr_dm0sl   dm0sl.bit.dsr          /* Software DMA request bit */



/*------------------------------------------------------

     dm1sl

------------------------------------------------------*/





#define     dsel0_dm1sl dm1sl.bit.dsel0        /* DMA request cause select bit */

#define     dsel1_dm1sl dm1sl.bit.dsel1        /* DMA request cause select bit */

#define     dsel2_dm1sl dm1sl.bit.dsel2        /* DMA request cause select bit */

#define     dsel3_dm1sl dm1sl.bit.dsel3        /* DMA request cause select bit */

#define     dms_dm1sl   dm1sl.bit.dms          /* DMA request cause expansion bit */

#define     dsr_dm1sl   dm1sl.bit.dsr          /* Software DMA request bit */



/********************************************************

*   declare SFR union                                   *

********************************************************/



union word_def_1 {

    struct{

        char    b0:1;

        char    b1:1;

        char    b2:1;

        char    b3:1;

        char    b4:1;

        char    b5:1;

        char    b6:1;

        char    b7:1;

        char    b8:1;

        char    b9:1;

        char    b10:1;

        char    b11:1;

        char    b12:1;

        char    b13:1;

        char    b14:1;

        char    b15:1;

        char    b16:1;

        char    b17:1;

        char    b18:1;

        char    b19:1;

    }bit;

    struct{

        char    low;                /* low  8 bit */

        char    mid;                /* mid  8 bit */

        char    high;               /* high 8 bit */

        char    nc;                 /* non use */

    }byte;

    unsigned long   dword;

} ;

        /* Address match interrupt register 0 32 bit */

#define     rmad0l      rmad0.byte.low         /* Address match interrupt register 0 low  8 bit */

#define     rmad0m      rmad0.byte.mid         /* Address match interrupt register 0 mid  8 bit */

#define     rmad0h      rmad0.byte.high        /* Address match interrupt register 0 high 8 bit */

        /* Address match interrupt register 1 32 bit */

#define     rmad1l      rmad1.byte.low         /* Address match interrupt register 1 low  8 bit */

#define     rmad1m      rmad1.byte.mid         /* Address match interrupt register 1 mid  8 bit */

#define     rmad1h      rmad1.byte.high        /* Address match interrupt register 1 high 8 bit */

         /* DMA0 source pointer 32 bit */

#define     sar0l       sar0.byte.low          /* DMA0 source pointer low  8 bit */

#define     sar0m       sar0.byte.mid          /* DMA0 source pointer mid  8 bit */

#define     sar0h       sar0.byte.high         /* DMA0 source pointer high 8 bit */

         /* DMA1 source pointer 32 bit */

#define     sar1l       sar1.byte.low          /* DMA1 source pointer low  8 bit */

#define     sar1m       sar1.byte.mid          /* DMA1 source pointer mid  8 bit */

#define     sar1h       sar1.byte.high         /* DMA1 source pointer high 8 bit */

         /* DMA0 destination pointer 32 bit */

#define     dar0l       dar0.byte.low          /* DMA0 destination pointer low  8 bit */

#define     dar0m       dar0.byte.mid          /* DMA0 destination pointer mid  8 bit */

#define     dar0h       dar0.byte.high         /* DMA0 destination pointer high 8 bit */

         /* DMA1 destination pointer 32 bit */

#define     dar1l       dar1.byte.low          /* DMA1 destination pointer low  8 bit */

#define     dar1m       dar1.byte.mid          /* DMA1 destination pointer mid  8 bit */

#define     dar1h       dar1.byte.high         /* DMA1 destination pointer high 8 bit */



union word_def_2 {

    struct{

        char    b0:1;

        char    b1:1;

        char    b2:1;

        char    b3:1;

        char    b4:1;

        char    b5:1;

        char    b6:1;

        char    b7:1;

        char    b8:1;

        char    b9:1;

        char    b10:1;

        char    b11:1;

        char    b12:1;

        char    b13:1;

        char    b14:1;

        char    b15:1;

    }bit;

    struct{

        char    low;                /* low  8 bit */

        char    high;               /* high 8 bit */

    }byte;

    unsigned short  word;

} ;



             /* DMA0 transfer counter 16 bit */

#define     tcr0l   tcr0.byte.low              /* DMA0 transfer counter low  8 bit */

#define     tcr0h   tcr0.byte.high             /* DMA0 transfer counter high 8 bit */

             /* DMA1 transfer counter 16 bit */

#define     tcr1l   tcr1.byte.low              /* DMA1 transfer counter low  8 bit */

#define     tcr1h   tcr1.byte.high             /* DMA1 transfer counter high 8 bit */

              /* UART0 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */

#define     u0tbl   u0tb.byte.low              /* UART0 Transmit buffer register low  8 bit */

#define     u0tbh   u0tb.byte.high             /* UART0 Transmit buffer register high 8 bit */

              /* UART1 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */

#define     u1tbl   u1tb.byte.low              /* UART1 Transmit buffer register low  8 bit */

#define     u1tbh   u1tb.byte.high             /* UART1 Transmit buffer register high 8 bit */

              /* UART2 Transmit buffer register 16 bit ; Use "MOV" instruction when writing to this register. */

#define     u2tbl   u2tb.byte.low              /* UART2 Transmit buffer register low  8 bit */

#define     u2tbh   u2tb.byte.high             /* UART2 Transmit buffer register high 8 bit */

              /* CRC data register 16 bit */

#define     crcdl   crcd.byte.low              /* CRC data register low  8 bit */

#define     crcdh   crcd.byte.high             /* CRC data register high 8 bit */

               /* A/D register 0 16 bit */

#define     ad0l    ad0.byte.low               /* A/D register 0 low  8 bit */

#define     ad0h    ad0.byte.high              /* A/D register 0 high 8 bit */

               /* A/D register 1 16 bit */

#define     ad1l    ad1.byte.low               /* A/D register 1 low  8 bit */

#define     ad1h    ad1.byte.high              /* A/D register 1 high 8 bit */

               /* A/D register 2 16 bit */

#define     ad2l    ad2.byte.low               /* A/D register 2 low  8 bit */

#define     ad2h    ad2.byte.high              /* A/D register 2 high 8 bit */

               /* A/D register 3 16 bit */

#define     ad3l    ad3.byte.low               /* A/D register 3 low  8 bit */

#define     ad3h    ad3.byte.high              /* A/D register 3 high 8 bit */

               /* A/D register 4 16 bit */

#define     ad4l    ad4.byte.low               /* A/D register 4 low  8 bit */

#define     ad4h    ad4.byte.high              /* A/D register 4 high 8 bit */

               /* A/D register 5 16 bit */

#define     ad5l    ad5.byte.low               /* A/D register 5 low  8 bit */

#define     ad5h    ad5.byte.high              /* A/D register 5 high 8 bit */

               /* A/D register 6 16 bit */

#define     ad6l    ad6.byte.low               /* A/D register 6 low  8 bit */

#define     ad6h    ad6.byte.high              /* A/D register 6 high 8 bit */

               /* A/D register 7 16 bit */

#define     ad7l    ad7.byte.low               /* A/D register 7 low  8 bit */

#define     ad7h    ad7.byte.high              /* A/D register 7 high 8 bit */

#endif

